<template>
  <ObModal
    ref="modal"
    :title-second="titleSecond"
    :title="title"
    size="large"
  >
    <ob-form
      class="contract-service-form"
      :form-data="formData"
      :form-model="formModel"
      :is-read-only="!isDraft"
      data-qa="serviceForm"
      :dropdown-menu="dropdownMenu"
      :ok-text="isNew && !isCopyMode ? 'Добавить' : 'Сохранить'"
      cancel-text="Отменить"
      :is-submit-disabled="isSubmitDisabled"
      @submit="onSubmitHandler"
    >
      <ObSelect
        ref="serviceSelect"
        v-if="isNew"
        v-model="formData.uuid"
        label="Услуга"
        placeholder="Выберите из списка"
        :display-func="(data) => `${data.title}. ${data.subtitle}`"
        :remote-opt="{
          method: api.contract.getServices,
          loadEvent: 'open',
          arguments: {
            uuid: contract.uuid,
            caste: 'SIMPLE'
          }
        }"
        :is-search="true"
        property="uuid"
        class="mb20"
        data-qa="service"
        @selected="selectedService"
      />
      <div class="sub-title">
        <span>Укажите налог на добавленную стоимость (НДС)</span>
        <ObTooltip content="НДС">
          <i class="icon question" />
        </ObTooltip>
      </div>
      <ObRadio
        v-if="isNew"
        v-model="formData.isNds"
        label="Не облагается НДС"
        :valueInput="false"
        class="mb10"
        data-qa="isNotNds"
        :readonly="isVatPayer || isCopyMode"
        @change="clearNds"
      />
      <ObRadio
        v-model="formData.isNds"
        v-if="isNew"
        label="Облагается НДС"
        :valueInput="true"
        class="mb10"
        :readonly="!isVatPayer || isCopyMode"
        data-qa="isNds"
        @change="setDefaultNds"
      />
      <transition name="toggle-height">
        <div
          class="checkbox-input"
          :class="isNew && 'ml25'"
        >
          <template v-if="formData.vatType !== 'NO_VAT'">
            <ObInput
              v-model="formData.vatRate"
              label="Величина НДС"
              sub-title="%"
              placeholder="Укажите"
              class="input-nds"
              type="number:strict"
              :readonly="true"
              data-qa="vatValue"
            />
            <ObCheckbox
              v-model="formData.isVatInclude"
              label="Тарифы указываются с учетом НДС"
              data-qa="isVatInclude"
              :disabled="!isDraft || isCopyMode"
              @change="onChangeIsVatIncluded"
            />
          </template>
          <template v-if="formData.vatType === 'NO_VAT' && !isNew">
            Не облагается НДС
          </template>
        </div>
      </transition>
      <div class="row">
        <div class="col-xs-6">
          <div class="sub-title">Тариф допробега:</div>
          <div class="checkbox-input">
            <ObInput
              :value="getTariff('extraMileageTariff')"
              label="Тариф допробега"
              sub-title="₽/км"
              placeholder="Укажите"
              class="tariff-input"
              :readonly="!isDraft"
              type="money:2"
              data-qa="extraMileageTariff"
              @input="onInputTariff('extraMileageTariff', $event)"
            />
          </div>
        </div>
        <div class="col-xs-6">
          <div class="sub-title">Тариф за допточку:</div>
          <div class="checkbox-input">
            <ObInput
              :value="getTariff('extraPointTariff')"
              label="Тариф за допточку"
              sub-title="₽"
              placeholder="Укажите"
              type="money:2"
              class="tariff-input"
              :readonly="!isDraft"
              data-qa="extraPointTariff"
              @input="onInputTariff('extraPointTariff', $event)"
            />
          </div>
        </div>
      </div>
      <div
        v-if="!isCopyCorrect"
        class="copy-attention-info"
      >
        <i class="icon alert" />
        <span>Выберите услугу, чтобы сохранить изменения</span>
      </div>
      <div
        v-if="isCopyMode"
        class="directions-count"
      >
        Направлений: {{ dataSource.directionsCount }}
      </div>
    </ob-form>
  </ObModal>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import models from '@/models'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObRadio from 'common-components/src/obComponents/obRadio'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import ObModal from 'common-components/src/obComponents/obModal'
  import debounce from "debounce";

  export default {
    name: 'ContractTransportationBaseServiceModal',
    components: {
      ObSelect,
      ObInput,
      ObForm,
      ObCheckbox,
      ObRadio,
      ObTooltip,
      ObModal
    },
    mixins: [
      FormValidationMixin
    ],
    props: {
      title: {
        type: String,
        default: ''
      },
      titleSecond: {
        type: String,
        default: ''
      }
    },
    data () {
      return {
        api,
        isNds: true
      }
    },
    computed: {
      ...mapGetters({
        contract: 'contract/contract',
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      disabledKeyWords() {
        return this.isNew ? false : !this.dataSource.is_active
      },
      isNew() {
        return !this.dataSource?.uuid || this.isCopyMode
      },
      formModel() {
        const { vatType = 'NO_VAT', vatRate = 0, isVatInclude = false } = this.dataSource || {}

        if (this.isNew) {
          return models.contract.service({ isVatPayer: this.isVatPayer, caste: 'SIMPLE' })
        } else {
          return models.contract.serviceEdit({
            isVatPayer: this.isVatPayer,
            vatType,
            vatRate,
            isVatInclude,
            caste: 'SIMPLE'
          })
        }
      },
      dropdownMenu () {
        if (this.isNew || !this.isDraft) {
          return []
        } else {
          return [
            {
              title: 'Удалить услугу',
              className: 'menu-button-danger',
              method: this.deleteService
            }
          ]
        }
      },
      isCopyMode () {
        return this.dataSource?.isSourceToCopy
      },
      isSubmitDisabled () {
        return !this.isCopyCorrect ? true : undefined
      },
      isCopyCorrect () {
        return !this.isCopyMode || (this.isCopyMode && this.dataSource?.uuid !== this.formData?.uuid)
      }
    },
    methods: {
      afterInitForm () {
        if (this.$refs.serviceSelect) {
          this.$refs.serviceSelect.firstLoad = true
        }
      },
      open () {
        this.$refs.modal.open()
      },
      close () {
        this.$refs.modal.close()
      },
      onSubmitHandler () {
        let data = cloneDeep(this.formData)

        if (this.isCopyMode) {
          this.$emit('copy', { formData: data, sourceUuid: this.dataSource.uuid, model: this.formModel })
        } else {
          this.$emit('submit', { formData: data, model: this.formModel})
        }
      },
      async clearNds () {
        this.formData.vatRate = 0
        this.formData.vatType = 'NO_VAT'
        await this.calcTariff()
      },
      async setDefaultNds () {
        this.formData.vatRate = this.isVatPayer ? 20 : 0
        this.formData.vatType = this.isVatPayer ? 'TWENTY' : 'NO_VAT'
        await this.calcTariff()
      },
      selectedService (item) {
        this.formData.contractUuid = this.$route.params.id
        this.formData.serviceDictUuid = item.uuid
        this.formData.serviceUnitUuid = item.serviceUnitUuid
        this.formData.resourceTypeUuid = item.resourceTypeUuid
      },
      deleteService () {
        this.$emit('on-delete', { ...this.dataSource })
      },
      async onInputTariff (key, value) {
        this.formData[key][this.formData.isVatInclude ? 'priceWithVat' : 'priceWithoutVat'] = +value
        await this.calcTariff()
      },
      calcTariff: debounce(async function() {
        let targetKeys = [ 'extraMileageTariff', 'extraPointTariff' ].filter(targetKey => {
          const isExistPrice = this.formData[targetKey]?.priceWithVat || this.formData[targetKey]?.priceWithoutVat
          const isValue = this.formData[targetKey]?.[this.formData.isVatInclude ? 'priceWithVat' : 'priceWithoutVat'] !== undefined
          return isExistPrice && isValue
        })

        let postData = targetKeys.map(targetKey => {
          const priceObject = this.formData.isVatInclude
            ? { priceWithVat: this.formData[targetKey]?.priceWithVat }
            : { priceWithoutVat: this.formData[targetKey]?.priceWithoutVat }
          return {
            vatRate: this.formData.vatRate,
            quantity: 1,
            ...priceObject
          }
        })

        if (this.formData.vatRate) {
          let { itemsList } = await api.orderProcess.vatCalculation({ list: postData })

          targetKeys.forEach((targetKey, index) => {
            const { priceWithVat, priceWithoutVat, vatValue } = itemsList[index] || {}
            this.formData[targetKey].priceWithVat = priceWithVat
            this.formData[targetKey].priceWithoutVat = priceWithoutVat
            this.formData[targetKey].vatPrice = vatValue
          })
        } else {
          targetKeys.forEach(targetKey => {
            this.formData[targetKey].priceWithVat = this.formData[targetKey]?.priceWithoutVat
            this.formData[targetKey].vatPrice = 0
          })
        }
      }, 500),
      onChangeIsVatIncluded () {
        this.$nextTick(() => {
          this.calcTariff()
        })
      },
      getTariff (key) {
        return this.formData.isVatInclude ? this.formData[key]?.priceWithVat : this.formData[key]?.priceWithoutVat
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-service-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
      .icon {
        margin-left: 3px;
        font-size: 14px;
        font-weight: bold;
        color: $color-grey-span;
      }
    }

    .tariff-input {
      width: 193px;
    }
  }
</style>

<style lang="scss" scoped>
@import '~common-components/src/static/css/mixins';
  .contract-service-form {
    .menu-button-danger {
      button {
        color: $color-error;
      }
    }

    .mt20 {
      margin-top: 20px!important;
    }

    .mb20 {
      margin-bottom: 20px!important;
    }

    .mb10 {
      margin-bottom: 10px;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .ml25 {
      margin-left: 25px;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }

    .input-nds {
      width: 145px;
    }

    .copy-attention-info {
      display: flex;
      align-items: center;
      margin: 30px 0;
      padding: 20px;
      background-color: rgba($color-error, 0.1);
      i {
        margin-right: 20px;
        font-size: 24px;
        color: $color-error;
      }
      span {
        @include font-mixin(14px, 20px, 400, $color-text-base);
      }
    }

    .directions-count {
      margin-top: 30px;
      margin-bottom: 40px;
      @include font-mixin(16px, 20px, 700, $color-text-base, 0.4px);
    }
  }
</style>
